#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Apr 30 14:30:59 2020

@author: valentinabadie
"""

import numpy as np
from library.Slide import *
from collections.abc import Iterable

path_slides = '../data/slides/'
path_labels = '../data/labels/'
path_infos = '../data/info_slides/'
        
class LevelSlide(Slide):
    
    """A class to handle a specified scale of a slide
    
    Attributes :
    
        Attributes coming from Slide class (class with super()) :
            path_slide : str, path to the file containing the slide (.ndpi)
            path_label : str, path to the file containing the labels (.p)
            path_info : list of str, path to the file containing the info file (.p), which is used to make slide and labels matching
            slide : openslide object
            level_dims : 2-tuple, size of the slide in pixels, at the thinner magnification level
            labels : list of 2 tuple containing the label of the associated object and its segmentation coordinates
            id : str, ID of the slide
            center : 2-tuple, coordinates of the center of the slide (in micrometers)
            step : 2-tuple, convertion rate between pixels and micrometers (in pixels/micrometers)
            limits : 2-tuple, coordinates of the limits of the slide (in micrometers)
            magnification_levels : list, levels of magnification available for the slide. If None, assumes that consecutive magnification levels have a x2 difference up to x40. Default : None.
        
        magnification : scaling level of the slide
        dims : dimensions of the level concerned
        _sampler_params : parameters of the sampler (size, stride, offset, borders, ROI, ROIp)
        sampler : an iterable wich samples regions from the level, according to the parameters settled in _sampler_params
        
    Methods :
    
        Built-in :
        
            __init__ : initilises the class
            __call__ : allows to call a rectangular region of this magnification level of the slide
            __str__ : displays a visual form of this magnification level
            __getitem__ : allows to get a region of the magnification level, according to the sampler parameters
            __len__ : number of regions which can be generated by the sampler

        Special : 
        
            update_sampler : changes the sampler, according the parameters set via _update_sampler_params
            meter_to_pixel : converts coordinates given in meters to coordinates in pixels for this magnification level
            pixel_to_meter : converts coordinates given in pixels to coordinates in meters for this magnification level
            reshape_pixel : sets all positions in pixel outside of this magnification level of the slide to be inside instead
            save : saves all regions of this magnification level, according to the sampler parameters

        Backend :
        
            _update_sampler_params : updates the sampler parameters
            _make_sampler : creates a sampler for this magnification level
    
    """
    
    def __init__(self, path_slide, path_label=None, path_info=None, magnification=-1):
        
        """initilises the class
        
        Inputs :
            path_slide : str, path to the file containing the slide (.ndpi)
            path_label : str, path to the file containing the labels (.p)
            path_info : list of str, path to the file containing the info file (.p), which is used to make slide and labels matching
            magnification : int or str, if int returns the magnification-th magnification level, starting from the greatest down to the smaller, if str return the corresponding magnification level. Default : -1.

        """
        
        super().__init__(path_slide, path_label = path_label, path_info = path_info)
        
        self.magnification = magnification
        
        if magnification == -1:
            self.magnification = len(self.level_dims) -1
            
        self.dims = self.level_dims[magnification]
        
        
        
        self._sampler_params = dict()
        
    def __call__(self, *coordinates, type_coord='meter', read_labels=True, read_mask=True):
        """Returns the region selected by the input coordinates.
        
        Inputs :
            coordinates : 4-tuple, the coordinates of the 4 points delimiting the rectangular region to be called.
            type_coord : str. If 'meter', the coordinates passed as input will be considered as real life meter coordinates, if 'pixel' it will be considered as pixel values on the magnification level. Default : 'meter'.
            read_labels : bool, if True retrieves the labels intersecting the region to be returned. Default : True.
            read_mask : bool, if True creates a mask associated with labels of the region. Default : True.
        
        """
        
        from library.Region import Region
        
        return Region(coordinates, self.path_slide, path_label = self.path_label, path_info = self.path_info, magnification = self.magnification, type_coord=type_coord, read_labels=read_labels, read_mask=read_mask)
    
    def __str__(self, read_labels = True):
        
        """Displays the whole level as a single region. WATCH OUT : it can induce RAM crashes for high resolution levels
        
        Inputs :
            read_labels : bool. If True, displays the labels of teh magnification level as well. Default : True.
        """
        
        from library.Region import Region
        print(Region((self.limits[0],self.limits[2],self.limits[1],self.limits[3]), self.path_slide, path_label = self.path_label, path_info = self.path_info, magnification = self.magnification, read_labels = read_labels, read_mask = False))
        return ''
    
    def __len__(self):
        """returns the number region which can be selected by the sampler"""
        return len(self.sampler)

    def __getitem__(self,index):
        
        """returns the region corresponding to the index passed as input
        
        Inputs :
            index : int, the index of the wanted region in the sampler.
        
        """
        
        if self._sampler_params['data_aug'] <= 1 :
            region = self.__call__(*self.sampler[index],type_coord ='pixel')
        else :
            region = [self.__call__(*self.sampler(index, idx),type_coord ='pixel') for idx in range(self._sampler_params['data_aug'])]
        return region
        
        
    def meter_to_pixel(self, *args):
        
        """Converts an information given in micrometers to an information in pixel position
        
        Arguments can be : 
            1 - type of coordinate,x1,x2,...: type_of_coordinate being a string ('x' for x axis, 'y' for y axis)
            2 - x1,y1,x2,y2,... : a tuple of paired coordinates
            3 - (x1,y1),(x2,y2),... : a list of 2-tuple pairs of coordinates
            4 - array([[x1,y1],[x2,y2],...]) : a n-by-2 array of coordinates
        """
        
        def mtr_px_arr(array):
            """this function is the restriction of meter_to_pixel to the 4th type of input data (array)"""
            
            #performs the transformation into pixels
            center_pixels = (np.array(self.dims)/2).reshape((-1, 2)).astype(float)
            array = center_pixels + (((array-self.center)*self.step)/2**self.magnification)
            array[:,1] = self.dims[1]-array[:,1] #flips coordinates on y axis
            
            return array.round().astype(int)
        
        # case 1
        if type(args[0]) is str :
            
            #since the first arg is to tell the type, the rest is only taken into account
            to_convert = np.array(args[1:]).reshape(-1, 1)
            converted = mtr_px_arr(np.concatenate((to_convert, to_convert), 1))
            
            #the output depends on the type of input
            if args[0] == 'x':
                return tuple(converted[:,0])
            if args[0] == 'y':
                return tuple(converted[:,1])
         
        #case 2
        if not isinstance(args[0], Iterable):
            
            #sets the 2n sized input to a n*2 array
            args = np.array(args)
            x_index = [x for x in range(0, len(args), 2)]
            y_index = [y for y in range(1, len(args), 2)]
            array_args = np.concatenate([args[x_index].reshape(-1,1), args[y_index].reshape(-1,1)], 1)
            
            #converts the values
            converted_array =  mtr_px_arr(array_args)

            #reshapes the result to have an input-like output
            args_out = np.zeros(len(args)).astype(int)
            args_out[x_index] = converted_array[:,0].reshape(-1)
            args_out[y_index] = converted_array[:,1].reshape(-1)
            
            return args_out
        
        #case 3
        if (type(args[0]) is tuple) or (type(args[0]) is list) :
            if (type(args[0][0]) is tuple) or (type(args[0][0]) is list) :
                return tuple([tuple(line) for line in mtr_px_arr(np.array(args[0]))])
            else :
                if len(args[0])==2:
                    return tuple([tuple(line) for line in mtr_px_arr(np.array(args))])
                else :
                    args = np.array(args[0])
                    x_index = [x for x in range(0, len(args), 2)]
                    y_index = [y for y in range(1, len(args), 2)]
                    array_args = np.concatenate([args[x_index].reshape(-1,1), args[y_index].reshape(-1,1)], 1)
                    
                    #converts the values
                    converted_array =  mtr_px_arr(array_args)
        
                    #reshapes the result to have an input-like output
                    args_out = np.zeros(len(args)).astype(int)
                    args_out[x_index] = converted_array[:,0].reshape(-1)
                    args_out[y_index] = converted_array[:,1].reshape(-1)
                    
                    return args_out
            
        #case 4
        if type(args[0]) is numpy.ndarray :
            return mtr_px_arr(args[0])
        
        return 'Input not in a proper format'
    
    def pixel_to_meter(self, *args):
        
        """Converts an information given in pixel position to an information in micrometers
        
        Arguments can be : 
            1 - type of coordinate,x1,x2,...: type_of_coordinate being a string ('x' for x axis, 'y' for y axis)
            2 - x1,y1,x2,y2,... : a tuple of paired coordinates
            3 - (x1,y1),(x2,y2),... : a list of 2-tuple pairs of coordinates
            4 - array([[x1,y1],[x2,y2],...]) : a n-by-2 array of coordinates
        """
        
        def px_mtr_arr(array):
            """this function is the restriction of pixel_to_meter to the 4th type of input data (array)"""

            #performs transformation into micrometers
            center = (np.array(self.dims)/2).reshape(-1, 2).astype(float)
            array[:,1] = self.dims[1] - array[:,1] #flips the y axis
            array = ((array.astype(float) - center)*2**self.magnification)/self.step + self.center
            
            return array
        
        # case 1
        if type(args[0]) is str :
            
            #since the first arg is to tell the type, the rest is only taken into account
            to_convert = np.array(args[1:]).reshape(-1, 1)
            converted = px_mtr_arr(np.concatenate((to_convert, to_convert), 1))
            
            #the output depends on the type of input
            if args[0] == 'x':
                return tuple(converted[:,0])
            if args[0] == 'y':
                return tuple(converted[:,1])
         
        #case 2
        if not isinstance(args[0], Iterable):
            
            #sets the 2n sized input to a n*2 array
            args = np.array(args)
            x_index = [x for x in range(0, len(args), 2)]
            y_index = [y for y in range(1, len(args), 2)]
            array_args = np.concatenate([args[x_index].reshape(-1,1), args[y_index].reshape(-1,1)], 1)
            
            #converts the values
            converted_array =  px_mtr_arr(array_args)

            #reshapes the result to have an input-like output
            args_out = np.zeros(len(args))
            args_out[x_index] = converted_array[:,0].reshape(1, -1)
            args_out[y_index] = converted_array[:,1].reshape(1, -1)
            
            return args_out
        
        #case 3
        if (type(args[0]) is tuple) or (type(args[0]) is list) :
            if (type(args[0][0]) is tuple) or (type(args[0][0]) is list) :
                return tuple([tuple(line) for line in px_mtr_arr(np.array(args[0]))])
            else :
                if len(args[0])==2:
                    return tuple([tuple(line) for line in px_mtr_arr(np.array(args))])
                else :
                    args = np.array(args[0])
                    x_index = [x for x in range(0, len(args), 2)]
                    y_index = [y for y in range(1, len(args), 2)]
                    array_args = np.concatenate([args[x_index].reshape(-1,1), args[y_index].reshape(-1,1)], 1)
                    
                    #converts the values
                    converted_array =  px_mtr_arr(array_args)
        
                    #reshapes the result to have an input-like output
                    args_out = np.zeros(len(args))
                    args_out[x_index] = converted_array[:,0].reshape(1, -1)
                    args_out[y_index] = converted_array[:,1].reshape(1, -1)
                    
                    return args_out
            
        #case 4
        if type(args[0]) is numpy.ndarray :
            return px_mtr_arr(args[0])
        
        return 'Input not in a proper format'
    
    def reshape_pixel(self, *args):
        """Sets all pixel coordinates outside of the image to be inside instead
        
        Arguments can be : 
            1 - type of coordinate,x1,x2,...: type_of_coordinate being a string ('x' for x axis, 'y' for y axis)
            2 - (x1,y1,x2,y2,...) : a tuple of paired coordinates
            3 - (x1,y1),(x2,y2),... : a list of 2-tuple pairs of coordinates
            4 - array([[x1,y1],[x2,y2],...]) : a n-by-2 array of coordinates
        """
        
        def rsp_en_arr(array):
            """this function is the restriction of pixel_to_meter to the 4th type of input data (array)"""
            
            bool_array_x_min = (array[:,0] >= 0).astype(int)
            bool_array_y_min = (array[:,1] >= 0).astype(int)
            bool_array_x_max = (array[:,0] <= self.dims[0]).astype(int)
            bool_array_y_max = (array[:,1] <= self.dims[1]).astype(int)
            
            array[:,0] = bool_array_x_min * bool_array_x_max * array[:,0] + (1 - bool_array_x_max) * (self.dims[0]-1)
            array[:,1] = bool_array_y_min * bool_array_y_max * array[:,1] + (1 - bool_array_y_max) * (self.dims[1]-1)

            return array
        
        # case 1
        if type(args[0]) is str :
            
            #since the first arg is to tell the type, the rest is only taken into account
            to_convert = np.array(args[1:]).reshape(-1,1)
            converted = rsp_en_arr(np.concatenate((to_convert, to_convert), 1))
            
            #the output depends on the type of input
            if args[0] == 'x':
                return tuple(converted[:,0])
            if args[0] == 'y':
                return tuple(converted[:,1])
         
        #case 2
        if not isinstance(args[0], Iterable):
            #sets the 2n sized input to a n*2 array
            args = np.array(args)
            
            x_index = [x for x in range(0, len(args), 2)]
            y_index = [y for y in range(1, len(args), 2)]
            array_args = np.concatenate([args[x_index].reshape(-1,1), args[y_index].reshape(-1,1)], 1)
            
            #converts the values
            converted_array =  rsp_en_arr(array_args)

            #reshapes the result to have an input-like output
            args_out = np.zeros(len(args)).astype(int)
            args_out[x_index] = converted_array[:,0].reshape(1, -1)
            args_out[y_index] = converted_array[:,1].reshape(1, -1)

            return args_out
        
        #case 3
        if (type(args[0]) is tuple) or (type(args[0]) is list) :
            if (type(args[0][0]) is tuple) or (type(args[0][0]) is list) :
                return tuple([tuple(line) for line in rsp_en_arr(np.array(args[0]))])
            else :
                if len(args[0])==2:
                    return tuple([tuple([int(i) for i in line]) for line in rsp_en_arr(np.array(args))])
                else :
                    args = np.array(args[0])
                    x_index = [x for x in range(0, len(args), 2)]
                    y_index = [y for y in range(1, len(args), 2)]
                    array_args = np.concatenate([args[x_index].reshape(-1,1), args[y_index].reshape(-1,1)], 1)
                    
                    #converts the values
                    converted_array =  rsp_en_arr(array_args)
        
                    #reshapes the result to have an input-like output
                    args_out = np.zeros(len(args)).astype(int)
                    args_out[x_index] = converted_array[:,0].reshape(1, -1)
                    args_out[y_index] = converted_array[:,1].reshape(1, -1)
                    
                    return args_out
        #case 4
        if type(args[0]) is numpy.ndarray :
            return rsp_en_arr(args[0])
    
    
    
    def _update_sampler_params(self, size=None, stride=None, offset=None, borders=None, ROI=None,ROIp=None,balance=None,tolerance=None,include_gray_matter=None, data_aug = None):
        
        """sets the parameters of the sampler. Some parameters may not be coherent as tolerance and stride, but they are used in different cases. Report to the method _make_sampler for more details.
        
        Inputs :
            size : 2-tuple, dimensions of each generated region
            stride : 2-tuple, the stride between 2 consecutive regions
            offset : 2-tuple, distance from the top-left of the slide to start picking regions
            border : bool, includes or not areas which are partly out of the slide
            ROI : int, if >0 then only triggers the regions which intersects the label corresping to the interger passed.                     Default 1
            ROIp : float in [0,1], if>0 only selects the region of which the fraction intersecting the ROI is at least above                   ROIp. Default 0.
            tolerance : int, in case of negative sample generation (i.e. no objects in it), say at which point the negative sample is needed to be negative, i.e. at what distance (in terms of infinite norm) the nearest object has to be away from the center of the sample.
            include_gray_matter : bool. If True, only regions in gray matter will be sampled; Defualt : True.
            data_aug : int. When generating a positive samples from an objects, says how many positive samples to generate from the same object. For more details, see report.
            balance : float. The balance between the number of positive and negative samples to be generated.
        """
        
        if size is not None :
            self._sampler_params['size'] = size
        
        if stride is not None :
            self._sampler_params['stride'] = stride
        
        if offset is not None :
            self._sampler_params['offset'] = offset
        
        if borders is not None :
            self._sampler_params['borders'] = borders
        
        if ROI is not None :
            self._sampler_params['ROI'] = ROI
            
        if ROIp is not None :
            self._sampler_params['ROIp'] = ROIp
            
        if balance is not None:
            self._sampler_params['balance'] = balance
        else :
            self._sampler_params['balance'] = 0.5
            
        if tolerance is not None :
            self._sampler_params['tolerance'] = tolerance
        
        if include_gray_matter is not None :
            self._sampler_params['include_gray_matter'] = include_gray_matter
        else :
            self._sampler_params['include_gray_matter'] = True
            
        if data_aug is not None :
            self._sampler_params['data_aug'] = data_aug
        else :
            self._sampler_params['data_aug'] = 0
            
    def _make_sampler(self, random = True):
        
        """This function creates a sampler for the magnification level
        
        Inputs :
            random : bool. If True, creates a sampler which generate positive samples by targetting regions containing objects, and negative by randomization. The only parameters to be taken into account in this case are : size, ROI, balance, tolerance, include_gray_matter and data_aug. If False, generates samples one after the other, by simple 2-D constant stride sampling. The only parameters to be taken into account in this case are : size, ROI, ROIp, offset, stride, borders. Default : True.
        
        """
        
        #if random = True, takes RandomSampler as default sampler
        if random :
            from library.Samplers import RandomSampler
            self.sampler = RandomSampler(self, self._sampler_params['size'], ROI = self._sampler_params['ROI'],balance = self._sampler_params['balance'], tolerance = self._sampler_params['tolerance'], include_gray_matter = self._sampler_params['include_gray_matter'], data_aug = self._sampler_params['data_aug'])
            
        #else, creates a Determinist one
        else :
            from library.Samplers import DeterministSampler
            self.sampler = DeterministSampler(self, self._sampler_params['size'], self._sampler_params['stride'], self._sampler_params['offset'], self._sampler_params['borders'],self._sampler_params['ROI'],self._sampler_params['ROIp'])
            
    def update_sampler(self, size=None, stride=None, offset=None, borders=None, ROI=None, ROIp=None,balance=None,tolerance=None,include_gray_matter=None,random = True, data_aug = None):
        
        """This function makes a pipeline between _update_sampler_params and _make_sampler.
        
        Inputs :
            size : 2-tuple, dimensions of each generated region
            stride : 2-tuple, the stride between 2 consecutive regions
            offset : 2-tuple, distance from the top-left of the slide to start picking regions
            border : bool, includes or not areas which are partly out of the slide
            ROI : int, if >0 then only triggers the regions which intersects the label corresping to the interger passed.                     Default : 1.
            ROIp : float in [0,1], if>0 only selects the region of which the fraction intersecting the ROI is at least above                   ROIp. Default : 0.
            tolerance : int, in case of negative sample generation (i.e. no objects in it), say at which point the negative sample is needed to be negative, i.e. at what distance (in terms of infinite norm) the nearest object has to be away from the center of the sample.
            include_gray_matter : bool. If True, only regions in gray matter will be sampled; Defualt : True.
            data_aug : int. When generating a positive samples from an objects, says how many positive samples to generate from the same object. For more details, see report.
            balance : float. The balance between the number of positive and negative samples to be generated.
            
            random : bool. If True, creates a sampler which generate positive samples by targetting regions containing objects, and negative by randomization. The only parameters to be taken into account in this case are : size, ROI, balance, tolerance, include_gray_matter and data_aug. If False, generates samples one after the other, by simple 2-D constant stride sampling. The only parameters to be taken into account in this case are : size, ROI, ROIp, offset, stride, borders. Default : True.
            
        
        """
        self._update_sampler_params(size=size,stride=stride,offset=offset,borders=borders,ROI=ROI,ROIp=ROIp,balance=balance,tolerance=tolerance,include_gray_matter=include_gray_matter, data_aug = data_aug)
        
        self._make_sampler(random = random)
    
    
    def save(self,path=None):
        
        """Saves all regions to be generated by the sampler of the selected magnification level
        
        Inputs :
            path : str. Path to the folder where regions have to be saved. Default : None.
        """
        
        if path is None :
            path = self.path_labels
        
        name_folder = 'level_{}_{}_{}_{}_{}_{}_{}.p'.format(self.id,self.level,self._sampler_params['size'],self._sampler_params['stride'],self._sampler_params['offset'],'b' if self._sampler_params['borders'] else 'n',self._sampler_params['ROI'],self._sampler_params['ROIp'])
        
        try :
            os.mkdir(path+name_folder)
        except :
            pass
        
        for region in self:
            region.save(path+name_folder)
